unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private 錾 }

    backbuf:TBitmap;
    aa: Double;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses UMath;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  backbuf := TBitmap.Create;
  backbuf.Width  := ClientWidth;
  backbuf.Height := ClientHeight;
  aa := 0.0;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
const distance = -10.0;
var
  v:array[0..2]of TVector;
  vv:array[0..2]of TVector;
  m:TMatrix;

  i:integer;
  pt:array[0..3]of TPoint;
begin

  v[0].x := 0;
  v[0].y := 50;
  v[0].z := 0;

  v[1].x := 50;
  v[1].y := -50;
  v[1].z := 0;

  v[2].x := -50;
  v[2].y := -50;
  v[2].z := 0;

  m  := MatMul( MatUnInit, MatRotY( aa ) );

  aa := aa+0.05;

  for i:=0 to 2 do begin
    vv[i] := MatApply(m,v[i]);
    pt[i].x := (backbuf.Width  div 2) + Round(vv[i].x);
    pt[i].y := (backbuf.Height div 2) - Round(vv[i].y);
  end;
  pt[3]:=pt[0];

  BitBlt( backbuf.Canvas.Handle,0,0,backbuf.Width, backbuf.Height,0,0,0,WHITENESS );
  backbuf.Canvas.Polyline( pt );

  StretchBlt( Canvas.Handle,0,0,ClientWidth,ClientHeight,
              backbuf.Canvas.Handle, 0,0, backbuf.Width, backbuf.Height,
              SRCCOPY );
end;

end.
